/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/* tbt: tokenized binary tree
        used for sorting token probabilities by their delta from .5
        (abs(.5-p)) delta becomes the key of the btree */

#ifndef _TBT_H
#define _TBT_H

enum
{ tbt_num_primes = 28 };

/* tbt root */
struct tbt
{
  unsigned long items;
  struct tbt_node *root;
  int type;
};

/* tbt node (a single long hashed token) */
struct tbt_node
{
  double delta;
  float probability;
  unsigned long long token;
  unsigned long frequency;
  int complexity;
  struct tbt_node *left;
  struct tbt_node *right;
  struct tbt_node *parent;
};

/* constructor and destructor */
struct tbt *tbt_create (void);
int tbt_destroy (struct tbt *tbt);

/* read-only functions */
struct tbt_node *tbt_first (struct tbt *tbt);
struct tbt_node *tbt_next (struct tbt_node *node);

/* read-write functions */
int tbt_add (struct tbt *tbt, double probability, unsigned long long token, unsigned long frequency, int complexity);

#endif /* _TBT_H */
