/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifdef HAVE_CONFIG_H
#include <auto-config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <dirent.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#include "../libdspam.h"

int stat_user (const char *username);
int process_all_users (void);

#define NGSTATS_IP	"64.202.131.2"
#define NGSTATS_PORT	80
#define NGSTATS_HOST	"www.nuclearelephant.com"
#define NGSTATS_CGI	"/cgi-bin/dspam_ngstats"

/* Set this unique ID if you don't have a static public ip address */
#define NGSTATS_UID	""

unsigned long ts = 0, ti = 0, sm = 0, fp = 0;

int
main (int argc, char **argv)
{
  struct sockaddr_in addr;
  int sock;
  char get[1024];

  dspam_init_driver ();

  process_all_users ();

  printf ("Reporting: TS: %ld TI: %ld SM: %ld FP: %ld...\n", ts, ti, sm, fp);

  sock = socket (AF_INET, SOCK_STREAM, 0);
  memset (&addr, 0, sizeof (struct sockaddr_in));
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = inet_addr (NGSTATS_IP);
  addr.sin_port = htons (NGSTATS_PORT);
  if (connect
      (sock, (struct sockaddr *) &addr, sizeof (struct sockaddr_in)) < 0)
  {
    fprintf (stderr, "unable to connect to %s: %s\n",
             NGSTATS_HOST, strerror (errno));
    dspam_shutdown_driver ();
    exit (EXIT_FAILURE);
  }

  snprintf (get, sizeof (get),
            "GET %s?ts=%ld&ti=%ld&sm=%ld&fp=%ld&uid=%s HTTP/1.1\n"
            "Host: %s\n" "Connection: close\n\n", NGSTATS_CGI, ts, ti,
            sm, fp, NGSTATS_UID, NGSTATS_HOST);

  if (send (sock, get, strlen (get) + 1, 0) < 0)
  {
    fprintf (stderr, "send failed: %s\n", strerror (errno));
  }
  else
  {
    printf ("Success!\n");
    close (sock);
  }

  dspam_shutdown_driver ();
  exit (EXIT_SUCCESS);
}

int
process_all_users (void)
{
  DSPAM_CTX *CTX;
  char *user;

  CTX = dspam_init (NULL, NULL, DSM_TOOLS, 0);
  if (CTX == NULL)
  {
    fprintf (stderr, "Could not initialize context: %s\n", strerror (errno));
    exit (EXIT_FAILURE);
  }

  user = _ds_get_nextuser (CTX);
  while (user != NULL)
  {
    stat_user (user);
    user = _ds_get_nextuser (CTX);
  }

  dspam_destroy (CTX);
  return 0;
}

int
stat_user (const char *username)
{
  DSPAM_CTX *CTX;

  CTX = dspam_init (username, NULL, DSM_CLASSIFY, 0);
  if (CTX == NULL)
  {
    fprintf (stderr, "Could not init context: %s\n", strerror (errno));
    return EUNKNOWN;
  }

  ts += CTX->totals.total_spam;
  ti += CTX->totals.total_innocent;
  sm += CTX->totals.spam_misclassified;
  fp += CTX->totals.innocent_misclassified;

  dspam_destroy (CTX);
  return 0;
}
