/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef _UTIL_H
#  define _UTIL_H

#ifdef HAVE_CONFIG_H
#include <auto-config.h>
#endif

void chomp (char *string);

/**
 *  Trim leading whitespace from string (by moving rest of string leftward).
 *  @param str
 *      String to trim.
 */
char *ltrim (char *str);
/**
 *  Trim trailing spaces (including newline and like characters).
 *  @param str
 *      String to trim.
 */
char *rtrim (char *str);
/**
 *  Trim both leading and trailing whitespace.
 *  @param str
 *      String to trim.
 */
#define alltrim(str)  ltrim(rtrim(str))
/**
 * Convert (and copy) string to lowercase.
 *
 * @param buff
 *      Destination buffer
 * @param string
 *      Source string to convert
 *
 * @return
 *      the number of characters converted to lowercase
 *
 * @note
 *      buffer and string can safely be set to the same memory pointer.
 */
int lc(char *buff, const char *string);


#ifndef HAVE_STRSEP
char *strsep (char **stringp, const char *delim);
#endif

#ifndef HAVE_STRLCPY
size_t strlcpy (char *, const char *, size_t);
size_t strlcat (char *, const char *, size_t);
#endif

const char *_ds_userdir_path (const char *filename, const char *extension);
int _ds_prepare_path_for (const char *filename);

#endif /* _UTIL_H */
